Bug 61135 - Implement a 'stepped lines' feature
Summary: Implement a 'stepped lines' feature
Status: RESOLVED FIXED
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: Chart (show other bugs)
Version:
(earliest affected)
4.1.0.0.alpha0+ Master
Hardware: x86-64 (AMD64) Linux (All)
: medium enhancement
Assignee: Eric Seynaeve
QA Contact:
URL:
Whiteboard: target:4.1.0
Keywords:
: 64472 (view as bug list)
Depends on:
Blocks:
 
Reported: 2013-02-19 21:13 UTC by Eric Seynaeve
Modified: 2013-05-11 16:42 UTC (History)
2 users (show)

See Also:
Crash report or crash signature:


Attachments
Patch for adding the actual stepped line code (4.64 KB, patch)
2013-02-19 21:34 UTC, Eric Seynaeve
Details
Screenshot of the result of stepped interpolation lines in Gnumeric (133.06 KB, image/png)
2013-02-20 20:31 UTC, Eric Seynaeve
Details
Screenshot how my code shows it at the moment in LO (133.70 KB, image/png)
2013-02-20 20:33 UTC, Eric Seynaeve
Details
ODS file saved by Gnumeric with stepped lines (116.32 KB, application/vnd.oasis.opendocument.spreadsheet)
2013-02-20 20:33 UTC, Eric Seynaeve
Details
Current Chart Wizard dialog (44.30 KB, image/png)
2013-03-05 21:57 UTC, Eric Seynaeve
Details
Mockup of new interface (44.23 KB, image/png)
2013-03-05 21:59 UTC, Eric Seynaeve
Details
Mockup of new interface with dropdown opened (46.52 KB, image/png)
2013-03-05 22:02 UTC, Eric Seynaeve
Details
Mockup of new interface with dropdown closed (44.07 KB, image/png)
2013-03-05 22:06 UTC, Eric Seynaeve
Details
The code for drawing the stepped lines (19.15 KB, patch)
2013-03-05 22:21 UTC, Eric Seynaeve
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Eric Seynaeve 2013-02-19 21:13:10 UTC
As also mentioned on https://wiki.documentfoundation.org/Development/Crazy_Ideas#.27Stepped_lines.27_option_in_Calc_charts, it would be nice for LO to contain a 'stepped line' type of curve next to straight lines and smooth lines.
Comment 1 Eric Seynaeve 2013-02-19 21:14:35 UTC
I have already implemented a first change to actually draw this type of lines.

This still has to be discussed on by people more expert than I ;-) and see how the UI and fileformat should be changed.
Comment 2 Eric Seynaeve 2013-02-19 21:34:43 UTC
Created attachment 75133 [details]
Patch for adding the actual stepped line code
Comment 3 Eric Seynaeve 2013-02-20 20:30:18 UTC
From the mailing list, it was pointed out that Gnumeric already has this feature.

I have created screenshots comparing what Gnumeric does and what my code does at the moment.

Also, the used test documents are added.

Eric
Comment 4 Eric Seynaeve 2013-02-20 20:31:46 UTC
Created attachment 75201 [details]
Screenshot of the result of stepped interpolation lines in Gnumeric
Comment 5 Eric Seynaeve 2013-02-20 20:33:02 UTC
Created attachment 75202 [details]
Screenshot how my code shows it at the moment in LO
Comment 6 Eric Seynaeve 2013-02-20 20:33:37 UTC
Created attachment 75203 [details]
ODS file saved by Gnumeric with stepped lines
Comment 7 Eric Seynaeve 2013-02-28 22:48:21 UTC
I have created a first part of the code so we can read the types provided by Gnumeric and also the ones defined by ODF1.3 (https://gerrit.libreoffice.org/2476).

I still need to add the UI elements for this.
Comment 8 Eric Seynaeve 2013-03-05 21:57:48 UTC
Created attachment 75983 [details]
Current Chart Wizard dialog

The current dialog for scatter charts. It's similar for line charts.
Comment 9 Eric Seynaeve 2013-03-05 21:59:09 UTC
Created attachment 75984 [details]
Mockup of new interface

Mockup of proposal for new interface. With Straight lines, the Properties button should be disabled.
Comment 10 Eric Seynaeve 2013-03-05 22:02:07 UTC
Created attachment 75985 [details]
Mockup of new interface with dropdown opened

Mockup with the dropdown opened.

When an item is selected, the graph glyphs should be changed accordingly.

As options in the properties for stepped lines, we should have 4 types:
- step at beginning
- step at end
- step at half X
- step to half Y
with corresponding glyphs of course.
Comment 11 Eric Seynaeve 2013-03-05 22:04:25 UTC
Comment on attachment 75984 [details]
Mockup of new interface

Oops, wrong image for this one.
Comment 12 Eric Seynaeve 2013-03-05 22:06:30 UTC
Created attachment 75987 [details]
Mockup of new interface with dropdown closed

Mockup of the changes to the dialog box. Similar changes would happen for the Line type.

When having straight lines selected, the Properties button should be disabled.
Comment 13 Eric Seynaeve 2013-03-05 22:07:50 UTC
Comment on attachment 75202 [details]
Screenshot how my code shows it at the moment in LO

I now support the exact same types as Gnumeric which also look the same.
Comment 14 Eric Seynaeve 2013-03-05 22:21:19 UTC
Created attachment 75989 [details]
The code for drawing the stepped lines
Comment 15 Commit Notification 2013-03-19 01:42:50 UTC
EricSeynaeve committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=bf033461c5cb0053253f410da7f17dd2e12771c3

fdo#61135 stepped lines graph: handle ods files



The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds
Affected users are encouraged to test the fix and report feedback.
Comment 16 Eric Seynaeve 2013-04-12 21:05:54 UTC
Gui changes are pushed to gerrit: https://gerrit.libreoffice.org/3345
Comment 17 Commit Notification 2013-04-18 04:26:14 UTC
Eric Seynaeve committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=ff547f4646c88c739118bf3058823b8642a275ae

fdo#61135: adding help button to stepped lines dialog.



The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds
Affected users are encouraged to test the fix and report feedback.
Comment 18 Commit Notification 2013-04-18 04:38:31 UTC
Eric Seynaeve committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/help/commit/?id=41837c920a92e84ad8bf989f407e60898aa99209

fdo#61135 Adding stepped lines: changes to help system.



The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds
Affected users are encouraged to test the fix and report feedback.
Comment 19 Eric Seynaeve 2013-04-18 21:50:57 UTC
Help changes are pushed as well.
Comment 20 bfoman (inactive) 2013-05-11 16:42:53 UTC
*** Bug 64472 has been marked as a duplicate of this bug. ***